SystemOrganization addCategory: #Stripe!

Object subclass: #StripeObject
	instanceVariableNames: 'id created description apiKey values unsavedValues transientValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeObject commentStamp: 'PaulDeBruicker 6/1/2012 17:26' prior: 0!
The API docs are here: https://stripe.com/docs/api





Instance Variables:
	id	<Object>
	created	<DateAndTime>
	description	<ProtoObject | PseudoContext>
	apiKey	<ProtoObject | PseudoContext>
	values	<Dictionary>
	unsavedValues	<Collection>
	transientValues	<Collection>!

StripeObject subclass: #StripeCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeCard class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/cards'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
address_country
	^ self valueFor: 'address_country'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
address_country: anObject
	self setValue: 'address_country' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
address_line1
	^ self valueFor: 'address_line1'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
address_line1: anObject
	self setValue: 'address_line1' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
address_line2
	^ self valueFor: 'address_line2'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
address_line2: anObject
	self setValue: 'address_line2' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
address_state
	^ self valueFor: 'address_state'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
address_state: anObject
	self setValue: 'address_state' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
address_zip
	^ self valueFor: 'address_zip'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
address_zip: anObject
	self setValue: 'address_zip' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
cvc
	^ self valueFor: 'cvc'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
cvc: anObject
	self setValue: 'cvc' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
exp_month
	^ self valueFor: 'exp_month'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
exp_month: anObject
	self setValue: 'exp_month' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
exp_year
	^ self valueFor: 'exp_year'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
exp_year: anObject
	self setValue: 'exp_year' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
name
	^ self valueFor: 'name'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
name: anObject
	self setValue: 'name' to: anObject! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
number
	^ self valueFor: 'number'! !

!StripeCard methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
number: anObject
	self setValue: 'number' to: anObject! !

StripeObject subclass: #StripeCharge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeCharge class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/charges'! !

!StripeCharge class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newChargeFor: anAmount toCard: aCard
	^ self new charge: anAmount to: aCard with: ''! !

!StripeCharge class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newChargeFor: anAmount toCard: aCard withDescription: aDescription
	^ self new charge: anAmount to: aCard with: aDescription! !

!StripeCharge class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newChargeFor: anAmount toCustomer: aCustomer
	^ self new charge: anAmount asString toCustomer: aCustomer with: ''! !

!StripeCharge class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newChargeFor: anAmount toCustomer: aCustomer with: aDescription
	^ self new charge: anAmount toCustomer: aCustomer with: aDescription! !

!StripeCharge methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
charge: anAmount to: aCard with: aDescription
	| dict charge |
	dict := Dictionary new.
	dict at: 'amount' put: anAmount asString.	"amount must be in pennies e.g. 99 equals $0.99"
	dict at: 'description' put: (description := aDescription).
	dict at: 'currency' put: 'usd'.	"they only support USD right now`"
	dict at: 'card[number]' put: aCard number.
	dict at: 'card[cvc]' put: aCard cvc.
	dict at: 'card[exp_month]' put: aCard exp_month.
	dict at: 'card[exp_year]' put: aCard exp_year.
	aCard address_line1 notNil
		ifTrue: [ dict at: 'card[address_line1]' put: aCard address_line1 ].
	aCard address_zip notNil
		ifTrue: [ dict at: 'card[address_zip]' put: aCard address_zip ].
	self createWith: dict! !

!StripeCharge methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
charge: anAmount toCustomer: aCustomer with: aDescription
	| dict charge |
	dict := Dictionary new.
	dict at: 'amount' put: anAmount.	"amount must be in pennies e.g. 99 equals $0.99"
	dict at: 'customer' put: aCustomer id.
	dict at: 'description' put: (description := aDescription).
	dict at: 'currency' put: 'usd'.	"they only support USD right now`"
	self createWith: dict! !

!StripeCharge methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'charge'! !

!StripeCharge methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/15/2012 14:33'!
refund: anAmount
	| response |
	response := self httpClient
		formAt: 'amount' put: anAmount asString;
		url: self refundUrl;
		post.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | self refreshFrom: parsedResponse with: self class secretApiKey ]! !

!StripeCharge methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
refundUrl
	^ self class url , '/' , self id , '/refund'! !

StripeObject subclass: #StripeCoupon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeCoupon class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/coupons'! !

!StripeCoupon class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFrom: aDictionary
	"see https://stripe.com/docs/api?lang=curl#create_coupon 

you can't create more than one of the same coupon, so we check to see if the one you want to make exists and if not create it"

	| existingCoupon |
	existingCoupon := self retrieveWithId: (aDictionary at: 'id').
	^ existingCoupon isNil
		ifTrue: [ self new createWith: aDictionary ]
		ifFalse: [ existingCoupon ]! !

!StripeCoupon class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 13:06'!
retrieveWithId: anId
	| response client parsed |
	client := ZnClient new logToTranscript.
	client username: self secretApiKey password: ''.
	client url: self url , '/' , anId.
	response := client get.
	parsed := Json readFrom: response asString readStream.
	parsed
		at: 'error'
		ifPresent: [ :v | ^ nil ]
		ifAbsent: [ ^ StripeSystem convert: parsed toStripeObjectUsing: self secretApiKey ]! !

!StripeCoupon methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'coupon'! !

StripeObject subclass: #StripeCustomer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeCustomer class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/customers'! !

!StripeCustomer class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFromCard: aCard
	^ self new createFromCard: aCard with: Dictionary new! !

!StripeCustomer class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFromCard: aCard with: optionalDictionary
	^ self new createFromCard: aCard with: optionalDictionary! !

!StripeCustomer class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFromToken: aToken
	^ self new createFromToken: aToken with: Dictionary new! !

!StripeCustomer class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFromToken: aToken with: optionalDictionary
	^ self new createFromToken: aToken with: optionalDictionary! !

!StripeCustomer methodsFor: 'subscriptions' stamp: 'PaulDeBruicker 5/15/2012 12:28'!
cancelSubscriptionAtEndOfCurrentPeriod
	| response client |
	response := self httpClient
		queryAt: 'at_period_end' put: true;
		url: self subscriptionUrl;
		delete.
	self handleResponse: response andIfSuccessful: [ :parsedResponse | ^ parsedResponse at: 'status' = 'cancelled' ]! !

!StripeCustomer methodsFor: 'subscriptions' stamp: 'PaulDeBruicker 5/15/2012 12:28'!
cancelSubscriptionNow
	| response |
	response := self httpClient
		url: self subscriptionUrl;
		delete.
	self handleResponse: response andIfSuccessful: [ :parsedResponse | ^ (parsedResponse at: 'ended_at') notNil ]! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
coupon
	^ (self valueFor: 'discount') coupon! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
createFromCard: aCard with: optionalDictionary
	| dict |
	dict := Dictionary new.
	optionalDictionary keysAndValuesDo: [ :name :option | dict at: name put: option ].
	dict at: 'card[number]' put: aCard number.
	dict at: 'card[cvc]' put: aCard cvc.
	dict at: 'card[exp_month]' put: aCard exp_month.
	dict at: 'card[exp_year]' put: aCard exp_year.
	aCard address_line1 notNil
		ifTrue: [ dict at: 'card[address_line1]' put: aCard address_line1 ].
	aCard address_zip notNil
		ifTrue: [ dict at: 'card[address_zip]' put: aCard address_zip ].
	^ self createWith: dict! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
createFromToken: aToken with: optionalDictionary
	| dict |
	dict := Dictionary new.
	optionalDictionary keysAndValuesDo: [ :name :option | dict at: name put: option ].
	dict at: 'card' put: aToken.
	^ self createWith: dict! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
description
	^ self valueFor: 'description'! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
email
	^ self valueFor: 'email'! !

!StripeCustomer methodsFor: 'invoices' stamp: 'PaulDeBruicker 5/15/2012 12:25'!
getUpcomingInvoice
	| response |
	response := self httpClient
		url: self invoiceUrl;
		queryAt: 'customer' put: self id;
		get.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | ^ StripeSystem convert: parsedResponse toStripeObjectUsing: self class secretApiKey ]! !

!StripeCustomer methodsFor: 'invoices' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
invoiceUrl
	^ StripeInvoice url , '/upcoming'! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'customer'! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
plan
	^ self subscription plan! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
subscription
	^ self valueFor: 'subscription'! !

!StripeCustomer methodsFor: 'subscriptions' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
subscriptionUrl
	^ self updateUrl , '/subscription'! !

!StripeCustomer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
trial_end
	^ self subscription trial_end! !

!StripeCustomer methodsFor: 'subscriptions' stamp: 'PaulDeBruicker 5/16/2012 09:31'!
updateSubscriptionTo: aPlan
	| response dict |
	dict := Dictionary new.
	dict at: 'plan' put: aPlan id.
	response := self httpClient
		formAddAll: dict;
		url: self subscriptionUrl;
		post.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | self setValue: 'subscription' to: (StripeSubscription new refreshFrom: parsedResponse with: self class secretApiKey) ]! !

StripeObject subclass: #StripeDiscount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeDiscount class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	self shouldNotImplement! !

!StripeDiscount methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
coupon
	^ self valueFor: 'coupon'! !

StripeObject subclass: #StripeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeEvent class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 09:39'!
classUrlComponent
	^ '/events'! !

!StripeEvent class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:09'!
newWithEventDetailsFromStripeFor: anEventId
	| newEvent |
	newEvent := self new
		id: anEventId;
		retrieveFromStripe.
	self instances add: newEvent.
	^ newEvent! !

!StripeEvent class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 13:07'!
retrieveLast: aCount starting: anOffset ofType: anEventType
	| response client parsed |
	client := ZnClient new logToTranscript.
	client username: self secretApiKey password: ''.
	client url: self url.
	client queryAt: 'count' put: aCount asString.
	client queryAt: 'offset' put: anOffset asString.
	anEventType isEmptyOrNil
		ifFalse: [ client queryAt: 'type' put: anEventType ].
	response := client get.
	parsed :=  Json readFrom: response asString readStream.
	^ StripeSystem convert: (parsed at: 'data') toStripeObjectUsing: self secretApiKey! !

!StripeEvent methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 10:45'!
object
	^ 'event'! !

!StripeEvent methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 11:37'!
printOn: aStream
	aStream nextPutAll: self type! !

!StripeEvent methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 11:34'!
refreshFrom: aResponse with: anApiKey partially: aBoolean
	| removedKeys |
	aResponse
		at: 'error'
		ifPresent: [ :v | StripeError signal: ((aResponse at: 'error') at: 'message') ]
		ifAbsent: [ 
			apiKey := anApiKey.
			removedKeys := aBoolean
				ifTrue: [ Set new ]
				ifFalse: [ Set newFrom: (values keys difference: aResponse keys) ].
			unsavedValues := Set newFrom: aResponse keys.
			removedKeys
				do: [ :each | 
					values removeKey: each.
					transientValues add: each.
					unsavedValues remove: each ].
			unsavedValues copy
				do: [ :each | 
					| dataToConvert |
					dataToConvert := each = 'data'
						ifTrue: [ (aResponse at: 'data') at: 'object' ]
						ifFalse: [ aResponse at: each ].
					self setValue: each to: (StripeSystem convert: dataToConvert toStripeObjectUsing: anApiKey).
					transientValues remove: each ifAbsent: [  ].
					unsavedValues remove: each ifAbsent: [  ] ] ]! !

!StripeEvent methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 11:37'!
type
	^ self valueFor: 'type'! !

StripeObject subclass: #StripeInvoice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeInvoice class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/invoices'! !

!StripeInvoice class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 13:07'!
retrieveWithId: anId
	| response client parsed |
	client := ZnClient new logToTranscript.
	client username: self secretApiKey password: ''.
	client url: self url , '/' , anId.
	response := client get.
	parsed :=  Json readFrom: response asString readStream.
	parsed
		at: 'error'
		ifPresent: [ :v | ^ nil ]
		ifAbsent: [ ^ StripeSystem convert: parsed toStripeObjectUsing: self secretApiKey ]! !

!StripeInvoice methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'invoice'! !

StripeObject subclass: #StripeInvoiceItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeInvoiceItem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
charge: anAmount to: aCustomer
	| dict |
	dict := Dictionary new.
	dict at: 'customer' put: aCustomer id.
	dict at: 'amount' put: anAmount asString.
	dict at: 'currency' put: 'usd'.
	^ self newFrom: dict! !

!StripeInvoiceItem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/invoiceitems'! !

!StripeInvoiceItem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFrom: aDictionary
	"see https://stripe.com/docs/api?lang=curl#create_invoiceitem"

	^ self new createWith: aDictionary! !

!StripeInvoiceItem methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
amount
	^ self valueFor: 'amount'! !

!StripeInvoiceItem methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'invoiceitem'! !

!StripeInvoiceItem methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
updateAmountTo: anAmount
	| dict |
	dict := Dictionary new.
	dict at: 'amount' put: anAmount asString.
	dict at: 'currency' put: 'usd'.
	^ self updateWith: dict! !

!StripeObject class methodsFor: 'urls' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	self shouldNotImplement! !

!StripeObject class methodsFor: 'storing' stamp: 'PaulDeBruicker 10/24/2011 18:00'!
instances
	^ StripeSystem instancesOf: self! !

!StripeObject class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 10/24/2011 15:23'!
newFrom: aResponse using: anApiKey
	^ self new from: aResponse using: anApiKey! !

!StripeObject class methodsFor: 'keys' stamp: 'PaulDeBruicker 10/25/2011 16:53'!
publishableApiKey
	^ self testPublishableAPIKey! !

!StripeObject class methodsFor: 'storing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
removeTestObjects
	self instances removeAllSuchThat: [ :each | each isATestObject ]! !

!StripeObject class methodsFor: 'storing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
removeTestObjectsFromStripe
	| objs |
	objs := self retrieveLast: 100 starting: 0.
	objs do: [ :each | each deleteFromStripe ]! !

!StripeObject class methodsFor: 'retrieve' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
retrieveLast: aCount starting: anOffset
	^ self retrieveLast: aCount starting: anOffset for: ''! !

!StripeObject class methodsFor: 'retrieve' stamp: 'PaulDeBruicker 6/4/2012 13:07'!
retrieveLast: aCount starting: anOffset for: aCustomer
	| response client parsed |
	client := ZnClient new logToTranscript.
	client username: self secretApiKey password: ''.
	client url: self url.
	client queryAt: 'count' put: aCount asString.
	client queryAt: 'offset' put: anOffset asString.
	aCustomer isEmptyOrNil
		ifFalse: [ client queryAt: 'customer' put: aCustomer ].
	response := client get.
	parsed := Json readFrom: response asString readStream.
	^ StripeSystem convert: (parsed at: 'data') toStripeObjectUsing: self secretApiKey! !

!StripeObject class methodsFor: 'keys' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
secretApiKey
	^ self testSecretApiKey! !

!StripeObject class methodsFor: 'urls' stamp: 'PaulDeBruicker 10/25/2011 19:29'!
stripeBaseUrl
	^ 'https://api.stripe.com/v1'	"',self apiKey ,'@"! !

!StripeObject class methodsFor: 'keys' stamp: 'PaulDeBruicker 12/16/2011 16:39'!
testPublishableAPIKey
	^ 'Your test publishable key'! !

!StripeObject class methodsFor: 'keys' stamp: 'PaulDeBruicker 12/16/2011 16:39'!
testSecretApiKey
	^ 'Your test secret key'! !

!StripeObject class methodsFor: 'urls' stamp: 'PaulDeBruicker 10/26/2011 07:20'!
url
	^ self stripeBaseUrl , self classUrlComponent! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
asJson
	^ values asJson! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/15/2012 14:21'!
createWith: aDictionary
	| response |
	response := self httpClient
		formAddAll: aDictionary;
		url: self class url;
		post.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | 
			self refreshFrom: parsedResponse with: self class secretApiKey.
			self class instances add: self.
			created := DateAndTime now ]! !

!StripeObject methodsFor: 'deleting' stamp: 'PaulDeBruicker 5/15/2012 12:26'!
deleteFromStripe
	| response |
	response := self httpClient
		url: self deleteUrl;
		delete.
	self handleResponse: response andIfSuccessful: [ :parsedResponse | ^ parsedResponse at: 'deleted' ]! !

!StripeObject methodsFor: 'deleting' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
deleteUrl
	^ self class url , '/' , self id! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
from: aResponse using: anApiKey
	apiKey := anApiKey.
	id := aResponse at: 'id' ifAbsent: [  ].
	self refreshFrom: aResponse with: anApiKey! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/15/2012 14:20'!
handleResponse: aResponse andIfSuccessful: aOneArgBlock
	| parsedResponse |
	parsedResponse := self parseStripeResponse: aResponse.
	parsedResponse
		at: 'error'
		ifPresent: [ :v | StripeError new signal: ((parsedResponse at: 'error') at: 'message') ]
		ifAbsent: [ ^ aOneArgBlock value: parsedResponse ]! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
hasAnId
	^ true! !

!StripeObject methodsFor: 'retrieving' stamp: 'PaulDeBruicker 5/15/2012 12:23'!
httpClient
	| client |
	client := ZnClient new username: self class secretApiKey password: ''.
	StripeSystem logStripeClientToTranscript
		ifTrue: [ client logToTranscript ].
	^ client! !

!StripeObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
id
	^ id ifNil: [ id := self valueFor: 'id' ]! !

!StripeObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 11:37'!
id: anId
	self setValue: 'id' to: anId! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
initialize
	values := Dictionary new.
	unsavedValues := Set new.
	transientValues := Set new! !

!StripeObject methodsFor: 'deleting' stamp: 'PaulDeBruicker 6/1/2012 17:11'!
isATestObject
	^ self livemode! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
keys
	^ values keys! !

!StripeObject methodsFor: 'deleting' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
livemode
	^ self valueFor: 'livemode'! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 12:38'!
parseStripeResponse: aResponse
	^ Json readFrom: aResponse readStream! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
refreshFrom: aResponse with: anApiKey
	^ self refreshFrom: aResponse with: anApiKey partially: false! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
refreshFrom: aResponse with: anApiKey partially: aBoolean
	| removedKeys |
	aResponse
		at: 'error'
		ifPresent: [ :v | StripeError signal: ((aResponse at: 'error') at: 'message') ]
		ifAbsent: [ 
			apiKey := anApiKey.
			removedKeys := aBoolean
				ifTrue: [ Set new ]
				ifFalse: [ Set newFrom: (values keys difference: aResponse keys) ].
			unsavedValues := Set newFrom: aResponse keys.
			removedKeys
				do: [ :each | 
					values removeKey: each.
					transientValues add: each.
					unsavedValues remove: each ].
			unsavedValues copy
				do: [ :each | 
					self setValue: each to: (StripeSystem convert: (aResponse at: each) toStripeObjectUsing: anApiKey).
					transientValues remove: each ifAbsent: [  ].
					unsavedValues remove: each ifAbsent: [  ] ] ]! !

!StripeObject methodsFor: 'retrieving' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
retrievalUrl
	^ self class url , '/' , self id! !

!StripeObject methodsFor: 'retrieving' stamp: 'PaulDeBruicker 5/15/2012 12:28'!
retrieveFromStripe
	| response client |
	response := self httpClient
		url: self retrievalUrl;
		get.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | ^ StripeSystem convert: parsedResponse toStripeObjectUsing: self class secretApiKey ]! !

!StripeObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:32'!
setValue: anApiParameter to: anObject
	self values at: anApiParameter put: anObject! !

!StripeObject methodsFor: 'deleting' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
updateUrl
	^ self class url , '/' , self id! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/15/2012 14:44'!
updateWith: optionalDictionary
	| response |
	response := self httpClient
		formAddAll: optionalDictionary;
		url: self updateUrl;
		post.
	self
		handleResponse: response
		andIfSuccessful: [ :parsedResponse | self refreshFrom: parsedResponse with: self class secretApiKey partially: true ]! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
url
	^ self class url , '/' , id greaseString encodeForHTTP! !

!StripeObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
valueFor: anApiParameter
	^ self values at: anApiParameter! !

!StripeObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
values
	^ values! !

StripeObject subclass: #StripePlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripePlan class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/plans'! !

!StripePlan class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFrom: aDictionary
	"see https://stripe.com/docs/api?lang=curl#create_plan 

you can't create more than one of the same plan, so we check to see if the one you want to make exists and if not create it"

	| existingPlan |
	existingPlan := self retrieveWithId: (aDictionary at: 'id').
	^ existingPlan isNil
		ifTrue: [ self new createWith: aDictionary ]
		ifFalse: [ existingPlan ]! !

!StripePlan class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 13:07'!
retrieveWithId: anId
	| response client parsed |
	client := ZnClient new logToTranscript.
	client username: self secretApiKey password: ''.
	client url: self url , '/' , anId.
	response := client get.
	parsed :=  Json readFrom: response asString readStream.
	parsed
		at: 'error'
		ifPresent: [ :v | ^ nil ]
		ifAbsent: [ ^ StripeSystem convert: parsed toStripeObjectUsing: self secretApiKey ]! !

!StripePlan methodsFor: 'comparing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ id = anObject id! !

!StripePlan methodsFor: 'comparing' stamp: 'PaulDeBruicker 5/15/2012 15:46'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ id hash! !

!StripePlan methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 09:27'!
name
	^ self valueFor: 'name'! !

!StripePlan methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
object
	^ 'plan'! !

StripeObject subclass: #StripeSubscription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeSubscription class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/subscriptions'! !

!StripeSubscription methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/15/2012 15:00'!
object
	^ 'subscription'! !

!StripeSubscription methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
plan
	^ self valueFor: 'plan'! !

!StripeSubscription methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
status
	^ self valueFor: 'status'! !

!StripeSubscription methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
trial_end
	^ self valueFor: 'trial_end'! !

StripeObject subclass: #StripeToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeToken class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
classUrlComponent
	^ '/tokens'! !

!StripeToken class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
newFrom: aCard for: anAmount
	^ self new charge: anAmount to: aCard! !

!StripeToken methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
charge: anAmount to: aCard
	| dict charge |
	dict := Dictionary new.
	dict at: 'amount' put: anAmount.	"amount must be in pennies e.g. 99 equals $0.99"
	dict at: 'currency' put: 'usd'.	"they only support USD right now`"
	dict at: 'card[number]' put: aCard number.
	dict at: 'card[cvc]' put: aCard cvc.
	dict at: 'card[exp_month]' put: aCard exp_month.
	dict at: 'card[exp_year]' put: aCard exp_year.
	aCard address_line1 notNil
		ifTrue: [ dict at: 'card[address_line1]' put: aCard address_line1 ].
	aCard address_zip notNil
		ifTrue: [ dict at: 'card[address_zip]' put: aCard address_zip ].
	self createWith: dict! !

StripeObject subclass: #StripeTransfer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

!StripeTransfer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 10:45'!
object
	^ 'transfer'! !

Object subclass: #StripeSystem
	instanceVariableNames: 'root'
	classVariableNames: 'StripeObjectDictionary'
	poolDictionaries: ''
	category: 'Stripe'!

StripeSystem class
	instanceVariableNames: 'default webhookServer'!

!StripeSystem commentStamp: 'PaulDeBruicker 6/1/2012 17:26' prior: 0!
On Pharo you can use Zodiac in conjunction with the SqueakSSLPlugin to communicate with Stripe through HTTPS.  But on Gemstone you must either proxy the HTTPS traffic through a webserver (nginx, apache) or use stunnel.

As far as how things behave between the two platforms there should be no differences.  


To receive the Stripe API WebHooks you'll need to expose a port on your server to the internet or set up a reverse proxy from your webserver to your Smalltalk image and start a ZnServer listening on that port by running:

StripeSystem startWebhookServerOn: 8182

The API docs are here: https://stripe.com/docs/api!

StripeSystem class
	instanceVariableNames: 'default webhookServer'!

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
convert: aResponse toStripeObjectUsing: anAPIKey
	^ aResponse isDictionary
		ifTrue: [ (StripeObjectDictionary at: (aResponse at: 'object' ifAbsent: [ 'object' ])) newFrom: aResponse using: anAPIKey ]
		ifFalse: [ 
			aResponse isCollection
				ifTrue: [ aResponse collect: [ :each | self convert: each toStripeObjectUsing: anAPIKey ] ]
				ifFalse: [ aResponse ] ]! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:22'!
default
	^ default ifNil: [ default := self new ]! !

!StripeSystem class methodsFor: 'webhooks' stamp: 'PaulDeBruicker 6/4/2012 13:07'!
handleRequest: aRequest
	| jsonData |
	"should only be a POST from stripe"
	aRequest method == #POST
		ifTrue: [ 
			jsonData :=  Json readFrom: aRequest entity.
			(jsonData at: 'object') = 'event'
				ifTrue: [ 
					StripeEvent newWithEventDetailsFromStripeFor: (jsonData at: 'id').
					^ ZnResponse ok: nil ].
			^ ZnResponse serverError: nil ].
	^ ZnResponse badRequest: nil! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 12:44'!
initialize
	"
StripeSystem initialize
"

	self initializeStripeObjectDictionary.
	! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/16/2012 09:54'!
initializeStripeObjectDictionary
	StripeObjectDictionary := Dictionary new.
	StripeObjectDictionary at: 'charge' put: StripeCharge.
	StripeObjectDictionary at: 'customer' put: StripeCustomer.
	StripeObjectDictionary at: 'invoicetiem' put: StripeInvoiceItem.
	StripeObjectDictionary at: 'invoice' put: StripeInvoice.
	StripeObjectDictionary at: 'plan' put: StripePlan.
	StripeObjectDictionary at: 'coupon' put: StripeCoupon.
	StripeObjectDictionary at: 'card' put: StripeCard.
	StripeObjectDictionary at: 'discount' put: StripeDiscount.
	StripeObjectDictionary at: 'subscription' put: StripeSubscription.
	StripeObjectDictionary at: 'token' put: StripeToken.
	StripeObjectDictionary at: 'object' put: StripeObject.
	StripeObjectDictionary at: 'event' put: StripeEvent.
	StripeObjectDictionary at: 'transfer' put: StripeTransfer! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/24/2011 18:00'!
instancesOf: aClass
	^ self default instancesOf: aClass! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
logStripeClientToTranscript
	^ false! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
objectsToIds: aCollectionOrObject
	| returnValue |
	aCollectionOrObject isDictionary
		ifTrue: [ 
			returnValue := Dictionary new.
			aCollectionOrObject keysAndValuesDo: [ :key :val | returnValue at: key put: (self objectsToIds: val) ] ]
		ifFalse: [ 
			returnValue := (aCollectionOrObject isCollection and: [ aCollectionOrObject isString not ])
				ifTrue: [ aCollectionOrObject collect: [ :each | self objectsToIds: each ] ]
				ifFalse: [ aCollectionOrObject ] ].
	^ returnValue! !

!StripeSystem class methodsFor: 'webhooks' stamp: 'PaulDeBruicker 5/16/2012 10:41'!
startSampleWebhookServer
	self startWebhookServerOn: 8182! !

!StripeSystem class methodsFor: 'webhooks' stamp: 'PaulDeBruicker 5/16/2012 09:51'!
startWebhookServerOn: aPortNumber
	self stopWebhookServerOn: aPortNumber.
	self webhookServer: (ZnServer startOn: aPortNumber).
	self webhookServer delegate: self! !

!StripeSystem class methodsFor: 'webhooks' stamp: 'PaulDeBruicker 5/16/2012 10:08'!
stopWebhookServerOn: aPortNumber
	ZnServer defaultServerClass allInstances
		do: [ :eachService | 
			eachService port = aPortNumber
				ifTrue: [ eachService stop ] ]! !

!StripeSystem class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/24/2011 15:16'!
symbolizeNames: anObject
	| returnValue |
	anObject isDictionary
		ifTrue: [ 
			returnValue := Dictionary new.
			anObject keysAndValuesDo: [ :key :val | returnValue at: key asSymbol put: (self symbolizeNames: val) ] ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ returnValue := anObject collect: [ :each | self symbolizeNames: each ] ]
				ifFalse: [ returnValue := anObject ] ].
	^ returnValue! !

!StripeSystem class methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
webhookServer
	^ webhookServer! !

!StripeSystem class methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
webhookServer: aZnManagingMultiThreadedServer
	webhookServer := aZnManagingMultiThreadedServer! !

!StripeSystem methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/24/2011 17:58'!
at: aString
	^ self root at: aString ifAbsentPut: [ OrderedCollection new ]! !

!StripeSystem methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/24/2011 17:58'!
instancesOf: aClass
	^ self at: aClass name! !

!StripeSystem methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/24/2011 17:59'!
root
	^ root ifNil: [ root := IdentityDictionary new ]! !

Error subclass: #StripeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

StripeError subclass: #APIConnectionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

StripeError subclass: #APIError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

StripeError subclass: #AuthenticationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

StripeError subclass: #CardError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!

StripeError subclass: #InvalidRequestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe'!
StripeSystem initialize!
